#include <wx/app.h>
#include <wx/config.h>
#include "DFArcApp.hpp"
#include "DFArcFrame.hpp"
#include "dfilesystem.hpp"
#include "InstallVerifyFrame.hpp"

IMPLEMENT_APP(DFArcApp)

bool DFArcApp::OnInit( void )
{
    bool lContinue;
    if ( argc == 2 )
    {
        wxString lDmodPath( argv[1] );

        wxConfig lConfig( "DFArc2" );
        bool lListAllSubdirectories;
        bool lOverrideDinkDirectory;
        wxString lSpecifiedDinkDirectory;
        lConfig.Read( "List All Subdirectories", &lListAllSubdirectories );
        lConfig.Read( "Override Dink Directory", &lOverrideDinkDirectory );
        lConfig.Read( "Specified Dink Directory", &lSpecifiedDinkDirectory );
        DFilesystem* lDinkFileSystem = new DFilesystem( &lListAllSubdirectories, &lOverrideDinkDirectory, &lSpecifiedDinkDirectory );

        
        InstallVerifyFrame* lTemp = new InstallVerifyFrame( NULL, lDmodPath, lDinkFileSystem );
        ::wxYield();
        lTemp->ShowModal();
        lTemp->Destroy();
        lContinue = false;
    }
    else
    {
        DFArcFrame* lDFArcMainForm = new DFArcFrame( "DFArc2", wxDefaultPosition, wxSize( 550, 600 ) );
        lDFArcMainForm->Show( true );
        lContinue = true;
    }
    return lContinue;
}