#if !defined ( DFARCFRAME_HPP )
#define DFARCFRAME_HPP

#include "dfilesystem.hpp"
#include <wx/wx.h>
#include <wx/config.h>
#include <wx/wizard.h>

// Main Frame Class, no arguments.
class DFArcFrame : public wxFrame
{
public:
    DFArcFrame(const wxString &wxsTitle, const wxPoint &wxpPos, const wxSize &wxsSize);

    enum Identifier
    {
        ID_FileInstall = 0,
        
        ID_Play,
        ID_Edit,
        ID_Package,
        
	    ID_Debug,
	    ID_Joystick,
	    ID_Sound,
	    ID_Truecolor,
        ID_Windowed,
        
        ID_Download,
        ID_Refresh,
        ID_Uninstall,
        ID_Options,
        ID_Introduction,
        ID_Walkthroughs,
        ID_Forums,
        ID_Browse,

        ID_DmodTitleList
    };

    ~DFArcFrame()
    {
        delete DFS;
		delete mConfig;
    }
    
    DFilesystem* GetDFS()
    {
        return DFS;
    }
    
    void PrepareGUI();
    
    void Install(wxCommandEvent &Event);
    void onPackage(wxCommandEvent &Event);
       
    void OnQuit(wxCommandEvent &Event);
    void OnAbout(wxCommandEvent &Event);
    
    void ChangeDescription(wxCommandEvent &Event);
    void showOptions( wxCommandEvent& aEvent );
    void uninstall( wxCommandEvent& aEvent );
    
    void OnSetPlayOption(wxCommandEvent &Event);
    
    void OnPlay( wxCommandEvent& aEvent );
    void onEdit( wxCommandEvent& aEvent );

    void showIntroduction( wxCommandEvent& aEvent );
    void onDownload( wxCommandEvent& aEvent );
    void onWalkthroughs( wxCommandEvent& aEvent );
    void onForums( wxCommandEvent& aEvent );
    void onRefresh( wxCommandEvent& aEvent );
    void onBrowse( wxCommandEvent& aEvent );
	void refreshDmodList( void );
	void selectDmod( void );
    void onShow( wxShowEvent& aEvent );

private:
        
    DFilesystem *DFS;
	void DFArcFrame::initializeConfig( void );
	void DFArcFrame::updateConfig( void );
	void DFArcFrame::updateDescription( unsigned int aSelectedDmodIndex );
    DECLARE_EVENT_TABLE()

    void onWizardCancel( wxWizardEvent& aUnusedEvent );
    void onWizardFinished( wxWizardEvent& aUnusedEvent );
    
    wxTextCtrl *mDmodDescription;
    
    // Stuff on the Play Panel
	wxCheckBox *mDebug;
	wxCheckBox *mJoystick;
	wxCheckBox *mSound;
    wxCheckBox *mWindowed;
    wxCheckBox *mTrueColor;
    
    // Stuff on the Package Panel
    wxComboBox *PkgDirDropdown;
    wxTextCtrl *PkgNameText;
    wxStaticText *PkgStatusLabel;
    wxGauge *PkgStatusBar;
    wxButton *PkgButton;
    
    wxSizer *DFNotebookSizer;
    wxNotebook *DFNotebook;
    wxBoxSizer *DFMainSizer;
    wxStatusBar* mStatusBar;
    wxBitmapButton* mLogoButton;
    wxBitmap mLogoBitmap;
    
	wxListBox* mDmodList;
	wxString mSelectedDmod;

    wxBoxSizer* mButtonSizer;
    wxBoxSizer* mImageSizer;
    bool mShowDeveloperButtons;

	wxConfig* mConfig;
	bool mDebugValue;
	bool mJoystickValue;
	bool mSoundValue;
	bool mTrueColorValue;
	bool mWindowedValue;

    bool mPlayMovieValue;
    bool mWriteIniValue;
    bool mOverrideDinkDirectory;
    bool mListAllSubdirectories;
    bool mShowIntroduction;
    bool mCloseDfarcOnPlay;
    bool mWarnOnEdit;
    wxString mSpecifiedDinkDirectory;
    wxString mDinkExe;
    wxString mEditorExe;
    bool mNoDmods;
    wxButton* mPlayButton;
    wxButton* mEditButton;
    wxButton* mPackageButton;

	const std::vector< std::pair< wxString, wxString > >* mFolderTitlePairs;
};

#endif