#if !defined ( INSTALLVERIFYFRAME_HPP )
#define INSTALLVERIFYFRAME_HPP

#include <wx/wx.h>
#include "dfilesystem.hpp"
#include "tar.hpp"

enum
{
    ID_CANCEL,
    ID_INSTALL_BUTTON,
    ID_INSTALL_VERIFY_FRAME
};

class InstallVerifyFrame : public wxDialog
{
public:
	InstallVerifyFrame( wxWindow* aParent, const wxString& aFilePath, DFilesystem* aDinkFileSystem );
    ~InstallVerifyFrame( void );

    wxString getSelectedDmod( void );
protected:
private:
    DECLARE_EVENT_TABLE()

    void prepareFrame( void );
    void onQuit(wxCloseEvent &Event);
    void onQuit(wxCommandEvent &Event);
    void onInstall(wxCommandEvent &Event);

    wxTextCtrl* mmDmodDescription;
    wxButton* mCancelButton;
    wxButton* mInstallButton;

    bool mExtracting;
    wxString mDmodName;
    wxString mDmodFilePath;
    wxString mTarFilePath;
    wxString mSelectedDmod;
    DFilesystem* mDinkFileSystem;
    Tar* mTar;
};

#endif