#if !defined ( OPTIONS_HPP )
#define OPTIONS_HPP

#include <wx/wx.h>
#include <wx/config.h>

enum
{
    ID_WRITE_INI = 0,
    ID_PLAY_MOVIE,
    ID_LIST_ALL,

    ID_OVERRIDE_CHECK,
    ID_OVERRIDE_EDIT,
    ID_OVERRIDE_BROWSE,
    
    ID_DINK_EXE,
    ID_EDIT_EXE,

    ID_OKAY,
    ID_OP_CANCEL
};

class Options : public wxDialog
{
public:
    Options( wxConfig* aConfig, bool* aPlayMovieValue, bool* aWriteIniValue,
                  bool* aListAllSubdirectories, bool* aOverrideDinkDirectory,
                  wxString* aSpecifiedDinkDirectory, wxString* aDinkExe, wxString* aEditorExe,
                  bool* aShowDeveloperButtons, bool* aCloseDfarcOnPlay );
    ~Options( void );
protected:
private:
    DECLARE_EVENT_TABLE()
    void prepareDialog( wxArrayString& aExeFiles );
    void onOkay( wxCommandEvent& aEvent );
    void onCancel( wxCommandEvent& aEvent );
    void onQuit( wxCloseEvent& aEvent );
    void Options::onBrowse( wxCommandEvent& aEvent );
    wxConfig* mConfig;

    bool* mPlayMovieValue;
    bool* mWriteIniValue;
    bool* mOverrideDinkDirectory;
    bool* mListAllSubdirectories;
    wxString* mSpecifiedDinkDirectory;
    wxString* mDinkExe;
    wxString* mEditorExe;
    bool* mShowDeveloperButtons;
    bool* mCloseDfarcOnPlay;

    wxCheckBox* mWriteIniCheck;
    wxCheckBox* mPlayMovieCheck;
    wxCheckBox* mListAllCheck;
    wxCheckBox* mShowDeveloperCheck;
    wxCheckBox* mOverrideDinkDirectoryCheck;
    wxCheckBox* mCloseCheck;
    wxTextCtrl* mSpecifiedDinkDirectoryBox;
    wxButton* mBrowseButton;
    wxComboBox* mDinkExeBox;
    wxComboBox* mEditorExeBox;
    
};

#endif