#if !defined ( PACKAGE_HPP )
#define PACKAGE_HPP

#include <wx/wx.h>
#include "dfilesystem.hpp"

class Package : public wxDialog
{
public:
    Package(  const wxString& aDmodPath, const wxString& aDmodDescription, DFilesystem* aDFS  );
    ~Package( void );

    enum
    {
        ID_PACKAGE,
        ID_CANCEL,
        ID_BROWSE
    };

protected:
private:
    void prepareDialog( const wxString& aDmodDescription  );
    void onOkay( wxCommandEvent& aEvent );
    void onCancel( wxCommandEvent& aEvent );
    void onQuit( wxCloseEvent& aEvent );
    void onBrowse( wxCommandEvent& aEvent );

    wxTextCtrl* mIdentifier;
    wxTextCtrl* mDmodDizTitle;
    wxTextCtrl* mDmodDizInfo1;
    wxTextCtrl* mDmodDizInfo2;
    wxTextCtrl* mDmodDizDescription;
    wxCheckBox* mCleanupSaveDat;
    wxCheckBox* mCleanupThumbsDb;
    wxCheckBox* mPatch;
    wxTextCtrl* mPatchOriginalFile;
    wxButton* mPatchBrowse;
    wxButton* mOkay;
    wxButton* mCancel;

    DFilesystem* mDFS;

    wxString mSelectedDmod;

    DECLARE_EVENT_TABLE()
};

#endif