#include "RecursiveDelete.hpp"
#include <wx/dir.h>
#include <wx/wx.h>

RecursiveDelete::RecursiveDelete( bool aRemoveSaveGames ) :
    mRemoveSaveGames( aRemoveSaveGames ),
    mError( false )
{

    return;
}

RecursiveDelete::~RecursiveDelete( void )
{
    return;
}

wxDirTraverseResult RecursiveDelete::OnFile( const wxString& aFilename )
{
    bool lRemoveFile( true );

    // See if it is a save game file
    if ( mRemoveSaveGames == false )
    {
        wxString lFilename = aFilename.Mid( aFilename.Find( '\\', true ) + 1 );
        if ( lFilename.Mid( 0, 4 ).MakeUpper() == "SAVE" && lFilename.Mid( lFilename.Len() - 3 ).MakeUpper() == "DAT" )
        {
            lRemoveFile = false;
        }
    }

    // Remove the file
    if ( lRemoveFile == true )
    {
        if ( ::wxRemoveFile( aFilename ) == false )
        {
            ::wxLogError( "Could not remove %s", aFilename );
            mError = true;
        }
    }
    return wxDIR_CONTINUE;
}

wxDirTraverseResult RecursiveDelete::OnDir( const wxString& aDirname )
{
    RecursiveDelete lRecursiveDelete( false );
    wxDir* lDir = new wxDir( aDirname );
    lDir->Traverse( lRecursiveDelete );
    delete lDir;
    
    if ( lRecursiveDelete.getError() == false )
    {
        if ( ::wxRmdir( aDirname ) == false )
        {
            ::wxLogError( "Could not remove %s", aDirname );
            mError = true;
        }
    }
    else if ( mError == false )
    {
        mError = true;
    }

    return wxDIR_IGNORE;
}

bool RecursiveDelete::getError( void )
{
    return mError;
}