#include "dfarc.hpp"

// FRAME EVENT TABLE
BEGIN_EVENT_TABLE(DFDIZWindow, wxFrame)
    EVT_CLOSE(DFDIZWindow::OnQuit)
    
    EVT_BUTTON(ID_CREATE, DFDIZWindow::CreateDIZFile)
    EVT_BUTTON(wxID_EXIT, DFDIZWindow::Quit)
END_EVENT_TABLE()

// VIRTUAL OVERRIDES
void DFDIZWindow::OnQuit(wxCloseEvent &WXUNUSED(Event))
{
    this->MakeModal(false);
    this->Destroy();
}

void DFDIZWindow::Quit(wxCommandEvent &WXUNUSED(Event))
{
	this->MakeModal(false);
    this->Destroy();
}


// GUI for main screen (with no args).
void DFDIZWindow::PrepareGUI()
{
    wxPanel *DIZPanel = new wxPanel(this);
    
    wxBoxSizer *DIZWindowSizer = new wxBoxSizer(wxVERTICAL);
    
    // Add the directory selection list.
    wxBoxSizer *DirSizer = new wxBoxSizer(wxHORIZONTAL);
        DirSizer->Add(new wxStaticText(DIZPanel, -1,
            wxT("Package Directory:")), 1, wxEXPAND | wxALL, 10);
        
        DirList = new wxComboBox(DIZPanel, -1, "", wxDefaultPosition,
            wxDefaultSize, 0, NULL);
		// TODO: Actually populate and stuff.
            
        DirSizer->Add(DirList, 2, wxEXPAND | wxALL, 10);
        
    // Add the part about the DMOD title.
    wxBoxSizer *TitleSizer = new wxBoxSizer(wxHORIZONTAL);
        TitleSizer->Add(new wxStaticText(DIZPanel, -1, wxT("DMod Title:")), 1, wxEXPAND | wxALL, 10);
        
        DModTitle = new wxTextCtrl(DIZPanel, -1);
        
        TitleSizer->Add(DModTitle, 2, wxEXPAND | wxALL, 10);
        
    // Add the general description box.
    wxBoxSizer *DescriptionSizer = new wxBoxSizer(wxHORIZONTAL);
        DescriptionSizer->Add(new wxStaticText(DIZPanel, 01, wxT("DMod Description:")),
            1, wxEXPAND | wxALL, 10);
        
        DIZDescription = new wxTextCtrl(DIZPanel, -1, "", wxDefaultPosition, wxDefaultSize,
            wxTE_MULTILINE | wxTE_PROCESS_TAB | wxTE_BESTWRAP);
            
        DescriptionSizer->Add(DIZDescription, 2, wxEXPAND | wxALL, 10);
        
    wxBoxSizer *ButtonSizer = new wxBoxSizer(wxHORIZONTAL);
        ButtonSizer->Add(new wxStaticText(DIZPanel, -1, ""), 3, wxEXPAND | wxALL, 10);
        ButtonSizer->Add(new wxButton(DIZPanel, wxID_EXIT, wxT("Cancel")), 1, wxALL, 10);
        ButtonSizer->Add(new wxButton(DIZPanel, ID_CREATE, wxT("Create")), 1, wxALL, 10);
        
        
    DIZWindowSizer->Add(DirSizer, 1, wxEXPAND, 0);
    DIZWindowSizer->Add(TitleSizer, 1, wxEXPAND, 0);
    DIZWindowSizer->Add(DescriptionSizer, 5, wxEXPAND, 0);
    DIZWindowSizer->Add(ButtonSizer, 1, wxEXPAND, 0);
    
    DIZPanel->SetSizer(DIZWindowSizer);
}



void DFDIZWindow::CreateDIZFile(wxCommandEvent &Event)
{
     // Make sure everything's filled out
     if(DirList->GetValue() == "" || DModTitle->GetValue() == "" ||
         DIZDescription->GetValue() == "")
     {
         ::wxLogMessage("You left some of the fields blank.");
         return;
     }
     
     // Get a pointer so we don't have to reference it each iteration.
     DFilesystem *DFSPtr = DFMainPtr->GetDFS();
     // Copy it so we don't run the copy constructor each time.
     wxString strValue = DirList->GetValue();
     
     register size_t st_i = 0;
     
     
     // Get our selected directory.
     /*for(st_i = 0; st_i < DFSPtr->ReturnDirList().GetCount(); ++st_i)
     {
         if(DFSPtr->ReturnDirList().Item(st_i) == strValue)
         {
             break;
         }
     }*/
     
     // Grab our DIZ path.
     //strValue = DFSPtr->ReturnDIZPath(st_i);
     
     // New file.
     std::fstream f_Out;
     f_Out.open(strValue.c_str(), std::ios::out);
     
     f_Out << DModTitle->GetValue().c_str() << "\n";
     f_Out << DIZDescription->GetValue().c_str() << "\n";
     
     f_Out.close();
     
     // Re-populate the arrays.
     delete DFMainPtr;
     DFArcFrame *MainApp = new DFArcFrame( "DFArc 2.0", wxDefaultPosition, wxSize( 550, 600 ) );
     
     // Close the window.
     this->Close(true);
}
