#if !defined ( DFILESYSTEM_HPP )
#define DFILESYSTEM_HPP
#include <vector>

class DFilesystem
{
public:
    DFilesystem( const bool* aListAllSubdirectories, const bool* aOverrideDinkDirectory, const wxString* mSpecifiedDinkDirectory );
    DFilesystem( void );
    ~DFilesystem( void );   
       
    wxString getDinkPath( void );
	const std::vector< std::pair< wxString, wxString > >* getFolderTitlePairs( void );
	void populateFolderTitlePairs( wxString& aDinkPath );
	
    void GetAllFiles( wxArrayString &wxasFileList, wxString strPath );
    bool IsValidFilename( const char *sz );
    wxString getDmodDescription( wxString aDmodFolder );
    
    // void DFilesystem::FixSlashes(wxString &Path)
    //
    // Makes sure all \ are / and that the path ends with a /
    //
    // Returns: Nothing.
    //
    void FixSlashes(wxString &Path)
    {         
        for(register size_t st_i = 0; st_i < Path.Length(); ++st_i)
        {
            if(Path[st_i] == '/')
            {
                Path[st_i] = '\\';
            }
        }
         
        if(Path[Path.Length() - 1] != '\\')
        {
            Path.Append( '\\' );
        }
    }

    inline void MoveFile(const char *szSrc, const char *szDest)
    {
        #ifdef WIN32
            MoveFileEx(szSrc, szDest, MOVEFILE_REPLACE_EXISTING);
        #else
	    char *szCmd = new char[strlen(szSrc) + strlen(szDest) + 7];
	    strcpy(szCmd, "mv ");
            strcat(szCmd, szSrc);
	    strcat(szCmd, " \"");
	    strcat(szCmd, szDest);
	    strcat(szCmd, "\"");
            system(szCmd);
	    delete[] szCmd;
        #endif
    }
       
private:   
    
    const bool* mListAllSubdirectories;
    const bool* mOverrideDinkDirectory;
    const wxString* mSpecifiedDinkDirectory;
	wxString mDinkPath;
	std::vector< std::pair< wxString, wxString > >* mFolderTitlePairs;
	void addFolderTitlePair( wxString aFolder );
	
	wxString findDinkDir( void );

    // Gets all directories in the specified directory.
    void PopulateDirectoryArray(wxString &Path);
	
    // Stores the title list and the diz file locations.
    void PopulateDIZArrays();    
};
#endif