#include "dfarc.hpp"
#include <string>
#include <sstream>
#include <cmath>

//
// class Tar, const char* DecToOct(int n)
//
// PURPOSE: Convert n to octal.
// RETURNS: The string of the octal number.
//
void Tar::DecToOct(int n, char *sz, int iMaxSize)
{    
    memset(sz, 0, iMaxSize);
    
    int iN = n;
    int iDigit = 0;
    int iPlace = 0;
    
    while(iN > 0 && iMaxSize > iPlace)
    {
        iDigit = iN % 8;
        iN >>= 3; // 2^3 = 8
        
        sz[iPlace] = '0' + iDigit;
        
        iPlace++;
    }
    
    // It's backwards.  Fix it.
    register int j = strlen(sz) - 1;
    for(register int i = 0; i < j; i++, j--)
    {
        // WOOO!!! Let's h4X0r it up!
        sz[i] ^= sz[j] ^= sz[i] ^= sz[j];
    }
}


//
// class CTar, std::string OctToDec(int n)
//
// PURPOSE: Convert n from Octal to Decimal.
// RETURNS: The string of the decimal number.
//
const char* Tar::OctToDec(int n)
{
    int iN = n;
   	int iPlace = 0, iDigit = 0;
    double dResult = 0;

	while(iN > 0)
	{
        // Take the ones digit.
		iDigit = iN % 10;

		// Get rid of the last digit.
		iN /= 10;

		// Add it to the total. (8^Pos * digit).
		dResult += iDigit * pow(static_cast<double>(8), static_cast<double>(iPlace));

		// Move the place forward.
		iPlace++;
	}

	return ToString(static_cast<int>(dResult));
}

//
// class CTar, std::string ToString(int n)
//
// PURPOSE: Convert an int to a string.
// RETURNS: The string.
//
const char* Tar::ToString(int n)
{
    std::ostringstream ss;

    ss << n;

    return ss.str().c_str();
}

//
// class CTar, int RountTo512(int n)
//
// PURPOSE: Moves the number to the nearest multiple of 512.
// RETURNS: The new number.
//
int Tar::RoundTo512(int n)
{
    if(n % 512 == 0)
    {
        return n;
    }
    else
    {
        return (n - (n % 512)) + 512;
    }
}




//
// class CTar, std::string PadWithZeros(std::string &s, int iAcheiveSize)
//
// PURPOSE: Pads the left side of the string with zeroes to achieve the size of iAcheiveSize.
// RETURNS: The padded string.
//
bool Tar::PadWithZeros(char *s, int iszSize, int iAcheiveSize)
{
   /* int iPadSize = iAcheiveSize - strlen(s) - 1;
    bool bErr = false;
    char *sz;
    char *szPtr;
    
    // Allocate some memory.
    sz = new char[iAcheiveSize];
    
    // We'll need to free it afterwards.  Return true if this is necessary.
    if(iszSize < iAcheiveSize)
    {
        bErr = false;
    }

    // Memset the string with 0's.  Make sure the last is null.
    memset(sz, static_cast<int>('0'), iAcheiveSize);
    sz[iAcheiveSize - 1] = '\0';
    
    // Pad it.
    szPtr = sz;
    szPtr += iPadSize;
    
    if(bErr)
    {
        memcpy(szPtr, s, iAcheiveSize - iPadSize + 1);
        s = sz;
        return false;
    }
    else
    {
        memcpy(szPtr, s, iAcheiveSize - iPadSize + 1);
::wxLogFatalError("Size: %d, String: |%s|", iAcheiveSize, sz);
        memmove(s, sz, iszSize);
        delete[] sz;
        return true;
    }

    return false;*/


    // If it won't be big enough, return false.
    if(iszSize < iAcheiveSize)
    {
        return false;
    }

    std::ostringstream oss;
    oss.fill('0');
    oss.width(iAcheiveSize - 1);
    oss << s;

    strncpy(s, oss.str().c_str(), iszSize);
    s[iAcheiveSize - 1] = '\0';

    return true;
}



////////////////////
// Tar Operations //
////////////////////

//
// class CTar, bool VerifyChecksum(TarHeader *Header)
//
// PURPOSE: Ensures the internal Header checksum is valid.
// RETURNS: True if valid.
//          False otherwise.
bool Tar::VerifyChecksum(TarHeader *Header)
{
    char *CheckRecord = 0;
    int iChksum = 0;

    // Checksum is counted as if it was blank.  Let's back it up and clear it.
    memset(Header->Chksum, 0, sizeof(Header->Chksum));

    // Prepare the incrementor.
    CheckRecord = reinterpret_cast<char*>(Header);

    // Find the checksum.
    for(CheckRecord; (CheckRecord - reinterpret_cast<char*>(Header)) < 512; ++CheckRecord)
    {
        iChksum += static_cast<int>(*CheckRecord);
    }

    // Add 256 (2^8)
    iChksum += 256;

    char sz[8];
    DecToOct(iChksum, sz, 8);

    /*if(atoi(sz) == atoi(strChksum.c_str()))
    {
        return true;
    }*/

    //return false;
    return true;
}

